//===============================================================
// Tap_throw.cs by Mental Trousers
//===============================================================
// This is based on something similar by Writer. A few people
// requested that I add it to my script pack, so here it is :)
//===============================================================
include ("mt\\infoHud.cs");

//Loops until you're out of grenades/mines or you tap the grenade/mine
//key again
function mt::throwLoop (%item, %delta)
{
	if (invent::carryingItem (%item) && $mt::throwingLoop)
		{
		remoteEval(2048, throwItem, %item, %delta);

		if ($mt::throwMineLoop && %item==invent::getItemType ("Mine"))
			schedule ("mt::throwLoop ("@%item@", "@%delta@");", 0.1);
		else if ($mt::throwGrenadeLoop && %item==invent::getItemType ("Grenade"))
			schedule ("mt::throwLoop ("@%item@", "@%delta@");", 0.1);
		}
	else
		{
		event::trigger ("eventStopped"@%item@"Loop");
		$mt::throwingLoop=false;
		}
}

//You can either tap the mine key to start unloading them or you can
//press and release the mine key and throw a mine the usual way.
function mt::unloadMines ()
{
	if ($mt::throwingLoop)
		{
		$mt::throwingLoop=false;
		return;
		}
	if ($mt::keyTap)
		{
		%delta=$mt::throwMineStrength;
		if ($mt::throwMineLoop)
			{
			$mt::throwingLoop=true;
			mt::throwLoop (invent::getItemType ("Mine"), %delta);
			}
		else
			{
			$mt::throwingLoop=false;
			remoteEval(2048, throwItem, invent::getItemType ("Mine"), %delta);
			}
		}
	else
		{
		$mt::throwingLoop=false;
		throwRelease (Mine);
		if ($mt::mineBeacon)
			useItem(invent::item ("Beacon"));
		}
}

//You can either tap the grenade key to start unloading them or you can
//press and release the grenade key and throw a mine the usual way.
function mt::unloadGrenades ()
{
	if ($mt::throwingLoop)
		{
		$mt::throwingLoop=false;
		return;
		}
	if ($mt::keyTap)
		{
		%delta=$mt::throwGrenadeStrength;
		if ($mt::throwGrenadeLoop)
			{
			$mt::throwingLoop=true;
			mt::throwLoop (invent::getItemType ("Grenade"), %delta);
			}
		else
			{
			$mt::throwingLoop=false;
			remoteEval(2048, throwItem, invent::getItemType ("Grenade"), %delta);
			}
		}
	else
		{
		$mt::throwingLoop=false;
		throwRelease (Grenade);
		}
}


function mt::setTapTime ()
{
	throwStart ();
	$mt::keyTap=true;
	schedule ("$mt::keyTap=false;", $mt::tapTime);
}

action::mute (throwMinePressed, true);
action::mute (throwGrenadePressed, true);
action::mute (throwMineReleased, true);
action::mute (throwGrenadeReleased, true);

action::attach (throwMinePressed, mt::setTapTime);
action::attach (throwGrenadePressed, mt::setTapTime);
action::attach (throwMineReleased, mt::unloadMines);
action::attach (throwGrenadeReleased, mt::unloadGrenades);
