function invent::newItem (%mod, %num, %item, %ammo, %armours, %usePack)
{
	$invent::item::[%mod, %num]=%item;
	$invent::item::[%mod, %item]=%num;
	$invent::item::[%mod, %num, armours]=%armours;

	if (%ammo!="")
		$invent::itemAmmo::[%mod, %num]=%ammo;
	else
		$invent::itemAmmo::[%mod, %num]=-1;

	if (%usePack)
		$invent::item::[%mod, %num, "activateOrDeploy"]=true;
	return;
}

function invent::item (%item)
	{ return $invent::item::[util::currentMod(), %item]; }

function invent::canDeployOrActivate (%item)
{
	return $invent::item::[util::currentMod(), %item, "activateOrDeploy"];
}

function invent::getValidArmour (%item)
	{ return getWord ($invent::item::[util::currentMod(), %item, armours], 0); }

function invent::isValidArmour (%item, %armour)
{
	for (%i=0; (%num=getWord ($invent::item::[util::currentMod(), %item, armours], %i))!=-1;%i++)
		{
		if (%armour==%num)
			return true;
		}
	return false;
}

function invent::carryingItem (%weap)
	{ return (getItemCount($invent::item::[util::currentMod(), %weap])>0); }

function invent::haveAmmo (%weap)
	{ return (invent::getAmmoCount (%weap)>0); }

function invent::getAmmoCount (%weap)
{
	if ($invent::itemAmmo::[util::currentMod(), %weap]==-1)
		return 99;
	else
		return getItemCount ($invent::itemAmmo::[util::currentMod(), %weap]);
}

function invent::checkWeaponAndAmmo (%weap)
{
	if (invent::carryingItem (%weap) && invent::haveAmmo (%weap))
		$invent::lastCycle=0;
}

//The allows us to associate common items from base Tribes (such as "Repair Gun") with a uncommon items from mods etc
function invent::associateWith (%mod, %num, %item, %press, %release)
{
	$invent::associateWith[%mod, %item]=%num;
	if (%press!="")
		invent::associateActionsWithWeapon (%mod, %num, %press, %release);
}

function invent::getItemType (%name)
	{ return $invent::associateWith[util::currentMod(), %name]; }

function invent::newNonInventItem (%mod, %num, %item, %armours, %func)
{
	$invent::nonInventoryItem::[%mod, %num]=%item;
	$invent::nonInventoryItem::[%mod, %item]=%num;
	$invent::nonInventoryItem::[%mod, %item, "function"]=%func;   //function that will handle the non invent item.
	$invent::item::[%mod, %num, armours]=%armours;  //this is cheating, but wtf
	return;
}

function invent::nonInventItem (%item)
	{ return $invent::nonInventoryItem::[util::currentMod(), %item]; }

function invent::newDelayAfterBuy (%mod, %item, %period)
{
	$invent::buyDelay::[%mod, %item]=%period;
}

function invent::ensureBuyDelay (%item)
{
	if ($invent::buyDelay::[util::currentMod(), %item]=="")
		return "0.0";
	else
		return $invent::buyDelay::[util::currentMod(), %item];
}

function invent::newSellItemsFirst (%mod, %item, %itemList)
{
	if (%itemList!="")
		$invent::sellItemsFirst::[%mod, %item]=%itemList;
	return;
}

function invent::sellItemsFirst (%item)
	{ return $invent::sellItemsFirst::[util::currentMod(), %item]; }

function invent::setMountOnZoom (%mod, %item)
{
	$invent::mountOnZoom::[%mod]=$invent::mountOnZoom::[%mod]@%item@" ";
	$invent::zoomWeapon++;
	$invent::mountOnZoom::[%mod, %item]=true;
}

function invent::isMountOnZoom (%item)
	{ return $invent::mountOnZoom::[util::currentMod(), %item]; }

function invent::getMountOnZoomWeapon ()
{
	for (%i=0;%i<$invent::zoomWeapon;%i++)
		{
		%weap=getWord ($invent::mountOnZoom::[util::currentMod()], %i);
		if (invent::carryingItem (%weap) && invent::haveAmmo (%weap))
			%i=999;
		else
			%weap="";
		}
	return %weap;
}

function invent::setReverseFireWeapon (%mod, %item)
	{ $invent::reverseFire::[%mod, %item]=true; }

function invent::isReverseFireWeapon (%item)
	{ return $invent::reverseFire::[util::currentMod(), %item]; }

function invent::associateActionsWithWeapon (%mod, %item, %press, %release)
{
	if (!$invent::action::[%mod, lowest])
		$invent::action::[%mod, lowest]=%item;
	$invent::action::[%mod, %item, "press"]= %press;
	$invent::action::[%mod, %item, "release"]= %release;
	$invent::action::[%mod, highest]=%item;
}

function invent::getItemCount (%item)
{
	return getItemCount (invent::item (invent::getItemType (%item)));
}

function invent::newIsArmour (%mod, %item)
{
	if (%item=="")
		return;

	$invent::armours[%mod]++;
	$invent::armour::[%mod, %item]=true;
	if ($invent::armour[%mod]!="")
		$invent::armour[%mod]=$invent::armour[%mod]@" "@%item;
	else
		$invent::armour[%mod]=%item;
	return;
}

function invent::isArmour (%item)
	{ return $invent::armour[util::currentMod(), %item]; }

function invent::getCurrentArmour ()
{
	%temp=0;
	for (%i=0;%i<$invent::armours[util::currentMod()];%i++)
		{
		%arm=getWord ($invent::armour[util::currentMod()], %i);
		%temp=%temp+(getItemCount(invent::item (%arm))*%arm);
		}
	return %temp;
}
