function util::checkBackPack ()
{
	if (util::isFirstPerson ())
		{
		postAction (2048, IDACTION_VIEW, -0);
		schedule ("postAction (2048, IDACTION_VIEW, -0);", 0.3);
		}
	return;
}

function util::firstThirdToggle ()
{
	if ($util::isThirdPerson)
		$util::isThirdPerson=false;
	else
		$util::isThirdPerson=true;
}

function util::isThirdPerson ()
	{ return $util::isThirdPerson; }

function util::isFirstPerson ()
	{ return !$util::isThirdPerson; }

//%weap = the number
//this will make sure that the weapon actually mounts, sometimes they don't.
function util::mountWeapon (%weap)
{
	if (!$util::checkingWeaponMounting)
		{
		$util::checkingWeaponMounting=true;
		remoteEval (2048, useItem, %weap);
		schedule::add ("util::checkWeaponDidMount_ ("@%weap@");", 0.1, "aTag");
		}
	return;
}

function util::checkWeaponDidMount_ (%weap, %count)
{
	if ((%weap!=getMountedItem (0)) && (%count<5))
		{
		%count++;
		remoteEval (2048, useItem, %weap);
		schedule::add ("util::checkWeaponDidMount_ ("@%weap@", "@%count@");", 0.1, "aTag");
		}
	else if (%count<5)
		event::trigger (eventWeaponMountConfirmed);
	else
		event::trigger (eventWeaponMountNotConfirmed);
	$util::checkingWeaponMounting=false;
	return;
}

function util::stopCheckingWeapon (%weap)
{
	$util::checkingWeaponMounting=false;
	return;
}

function util::currentMod()
{
	if ($Mod::current=="")
		return "base";
	else
		return $Mod::current;
}

function util::checkResolution (%gui)
{
	if (%gui==playGui)
		{
		if ($pref::VideoFullScreenRes!=$util::VideoFullScreenRes)
			{
			$util::VideoFullScreenRes=$pref::VideoFullScreenRes;
			$util::resolutionXY=string::replace ($pref::VideoFullScreenRes, "x", " ");
			event::trigger (eventResolutionChange);
			}
		}
	return;
}
$util::VideoFullScreenRes=$pref::VideoFullScreenRes;

function screen::resX ()
	{ return getWord ($util::resolutionXY, 0); }

function screen::resY ()
	{ return getWord ($util::resolutionXY, 1); }

function screen::newContainer ()
{
	if ($screen::container=="")
		{
		$screen::container=newObject ("screenObjectContainer", simGui::Control, 0, 0, screen::resX(), screen::resY());
		addToSet (playGui, $screen::container);
		$screen::containerVisible=true;
		}
	return;
}

function screen::newObject (%name, %type, %x, %y, %w, %h, %vis)
{
	screen::newContainer ();
	%handle=newObject (%name, %type, %x, %y, %w, %h);
	control::setVisible (%name, %vis);
//	addToSet ($screen::container, %handle);
	addToSet ("screenObjectContainer", %handle);
	return %handle;
}

function screen::setContainerVisible ()
{
	addToSet (playGui, $screen::container);
	$screen::containerVisible=true;
	return;
}

function screen::ensureVisible (%gui)
{
	if (%gui==playGui)
		screen::setContainerVisible ();
	return;
}

function screen::toggleContainer ()
{
	if ($screen::containerVisible)
		{
		removeFromSet (playGui, $screen::container);
		$screen::containerVisible=false;
		}
	else
		{
		addToSet (playGui, $screen::container);
		$screen::containerVisible=true;
		}
	return;
}

function screen::playGuiOpenFirstTime (%gui)
{
	if (!$util::openedAlready && %gui==playGui)
		{
		$util::openedAlready=true;
		event::trigger (eventPlayGuiFirstOpen);
		}
	return;
}

function util::playerFirstSpawn()
{
	if (!$util::firstSpawn)
		{
		$util::firstSpawn=true;
		event::trigger (eventPlayerFirstSpawn);
		}
	return;
}

function util::detachPlayerFirstSpawnCheck ()
{
	if (!$util::firstSpawn)
		schedule::add ("util::detachPlayerFirstSpawnCheck ();", 30);
	else
		{
		event::detach (eventWeaponChanged, util::playerFirstSpawn);
		schedule::add ("event::detach (eventWeaponChanged, util::playerFirstSpawn);", 10);  //call it paranoia
		}
	return;
}

function util::regularCallBack (%str)
{
	$util::callback=$util::callback@%str;
	return;
}

function util::heartBeat ()
{
	eval ($util::callback);
	schedule::add ("util::heartBeat ();", $util::heartbeat);
	return;
}

function util::weaponChange (%weap)
{
	if (%weap!=$util::currentWeapon)
		{
		event::trigger (eventWeaponChanged, %weap);
		$util::currentWeapon=%weap;
		$reticle::util=%weap;
		}
	return;
}

function util::execModInfo()
{
	%ind=0;
	%cur=$Mod::current;                  //use this instead of the func call cos the func returns 'base' if the $Mod::current=""

	while ((%mod=getWord ($modList, %ind))!=-1)
		{
		%path="mt\\mods\\"@%mod@".cs";
		if (%mod==%cur || %path=="")
			break;
		if (isfile ("config\\"@%path))
			{
			event::trigger (eventEstablishedMod, %mod);
			$Mod::current=%mod;
			exec (%path);
			event::trigger (eventModInfoLoaded);
			return;
			}
		%ind++;
		}
	if ($Mod::current=="")
		{
		event::trigger (eventEstablishedMod, %mod);
		$Mod::current="base";
		exec ("mt\\mods\\base.cs");
		event::trigger (eventModInfoLoaded);
		}
	return;
}

function util::findIfBwadmin ()
{
	if (string::findSubStr ($modList, "bwadmin")!=-1)
	{
		util::bwadmin::Reset();
		event::trigger (eventBwadminSupportEnabled);
		schedule("event::trigger (eventPilotModeVersion);",1);
		schedule("event::trigger (eventStationModeVersion);",1);
		schedule("event::trigger (eventObjectiveModeVersion);",1);
		schedule("event::trigger (eventKillModeVersion);",1);
		schedule("event::trigger (eventWeaponChangeModeVersion);",1);
	}
	else
	{
		$util::isBwadminServer = false;
		event::trigger (eventPilotModeVersion);
		event::trigger (eventStationModeVersion);
		event::trigger (eventObjectiveModeVersion);
		event::trigger (eventKillModeVersion);
		event::trigger (eventWeaponChangeModeVersion);
	}
	return;
}

function util::bwadmin::Reset()
{
	remoteEval (2048, bwadmin::isCompatible, getManagerId());
}


function remotebwadmin::Compatible(%client, %version)
{
	//%version is the returned version of bwadmin
	//now that you know it is bwadmin you can request what
	//data you wish to recieve from bwadmin support

	//Set support check as false if no support within 1 second
	$util::isBwadminServer = true;
	schedule("if($util::bwadminStationType = \"\") $util::bwadminStationType = false;",0.5);
	schedule("if($util::bwadminObjectiveInfo = \"\") $util::bwadminObjectiveInfo = false;",0.5);
	schedule("if($util::bwadminPilotingInfo = \"\") $util::bwadminPilotingInfo = false;",0.5);
	schedule("if($util::bwadminKillInfo = \"\") $util::bwadminKillInfo = false;",0.5);
	schedule("if($util::bwadminWeaponChangeInfo = \"\") $util::bwadminWeaponChangeInfo = false;",0.5);


	//Check for support
	remoteEval (2048, bwadmin::EnableSupport, getManagerId(),"StationType");
//	remoteEval (2048, bwadmin::EnableSupport, getManagerId(),"ObjectiveInfo");
	remoteEval (2048, bwadmin::EnableSupport, getManagerId(),"PilotingInfo");
//	remoteEval (2048, bwadmin::EnableSupport, getManagerId(),"KillInfo");
//	remoteEval (2048, bwadmin::EnableSupport, getManagerId(),"WeaponChangeInfo");
}


function remotebwadmin::SupportVerify(%client, %type, %enable)
{
	if(%enable)
	{
		if(%type == "StationType")
		{
			$util::bwadminStationType = true;
			event::trigger (eventStationModeVersion);
		}
		else if(%type == "ObjectiveInfo")
		{
			$util::bwadminObjectiveInfo = true;
			event::trigger (eventObjectiveModeVersion);
		}
		else if(%type == "PilotingInfo")
		{
			$util::bwadminPilotingInfo = true;
			event::trigger (eventPilotModeVersion);
		}
		else if(%type == "KillInfo")
		{
			$util::bwadminKillInfo = true;
			event::trigger (eventKillModeVersion);
		}
		else if(%type == "WeaponChangeInfo")
		{
			$util::bwadminWeaponChangeInfo = true;
			event::trigger (eventWeaponChangeModeVersion);
		}
		echo("Compatible bwadmin ",%type," support detected");
	}
	else
	{
		if(%type == "StationType")
		{
			$util::bwadminStationType = false;
			event::trigger (eventStationModeVersion);
		}
		else if(%type == "ObjectiveInfo")
		{
			$util::bwadminObjectiveInfo = false;
			event::trigger (eventObjectiveModeVersion);
		}
		else if(%type == "PilotingInfo")
		{
			$util::bwadminPilotingInfo = false;
			event::trigger (eventPilotModeVersion);
		}
		else if(%type == "KillInfo")
		{
			$util::bwadminKillInfo = false;
			event::trigger (eventKillModeVersion);
		}
		else if(%type == "WeaponChangeInfo")
		{
			$util::bwadminWeaponChangeInfo = false;
			event::trigger (eventWeaponChangeModeVersion);
		}
		echo("This server does not have enhanced bwadmin client support for ",%type,", reverting to legacy support");
	}
}

$util::checkingWeaponMounting=false;
$util::isThirdPerson=false;
$util::openedAlready=0;
$screen::container="";

action::attach (firstThirdViewPressed, util::firstThirdToggle);

msg::onMatch ("Match started.", "event::trigger(eventMatchStarted);");
msg::onMatch ("You received a", "event::trigger(eventPickedUpBackPack);");

event::attach (eventGuiOpen, util::checkResolution);
event::attach (eventGuiOpen, screen::ensureVisible);
event::attach (eventGuiOpen, screen::playGuiOpenFirstTime);
event::attach (eventWeaponChanged, util::stopCheckingWeapon);
event::attach (eventConnectionAccepted, "schedule::add (\"util::heartBeat ();\", $util::heartbeat);");
event::attach (eventConnectionAccepted, "$util::openedAlready=false;");   //reset so demo drops etc work properly
event::attach (eventPlayerFirstSpawn, screen::newContainer);
event::attach (eventConnected, util::execModInfo);
event::attach (eventEstablishedMod, util::findIfBwadmin);
event::attach (eventPickedUpBackPack, util::checkBackPack);
event::attach (eventModInfoLoaded, "exec (\"MT\\\\MTPackPrefs.cs\");mt::initialiseDropFavs ();");
event::attach (eventWeaponChanged, util::playerFirstSpawn);
event::attach (eventPlayGuiFirstOpen, "schedule::add (\"util::detachPlayerFirstSpawnCheck ();\", 30);");

action::attach (hudConfigReleased, screen::toggleContainer );

NGS::register ("screenObjectContainer");
util::regularCallBack ("util::weaponChange (getMountedItem(0));");
