include ("mt\\infoHud.cs");
include ("mt\\station.cs");

function mt::preFavsDrop(%time)
{
	if (!mt::anyMoveKeyPressed () && $mt::doDropGroup)
		{
		mt::muteMoveButtons ();
		%time=mt::execDropGroups(%time);
		}
	else
		%time=0;
	mt::postDropGroups(%time);
	return;
}

function mt::postDropGroups(%time)
{
	if ($mt::favOpensInventScreen[util::currentMod(), $curFavorites])
		{
		remoteEval(2048, InventoryMode);
		mt::releaseMoveButtons ();
		mt::restoreMovement ();
		return;
		}

	$mt::doDropGroup=true;
	schedule ("cmdInventoryGui::buyFavorites ("@$curFavorites@");", %time);
	schedule ("event::trigger (eventFavouritesBought);", %time+0.1);
	schedule ("mt::releaseMoveButtons ();mt::restoreMovement ();", %time+0.2);
	return;
}

function mt::enteringInvent()
{
	if ((!$mt::favIsPortableOnly[util::currentMod(), $curFavorites] && $mt::doDropGroup) || $util::bwadminStationType)
		mt::quickHeal();

	mt::preFavsDrop(0.3);
	return;
}

function mt::enteringPortableInvent()
{
	mt::preFavsDrop(0.5);
	return;
}

function mt::enteringVehicleStation()
{
	if ($mt::fav[util::currentMod(), $curFavorites, "vehicle"]!="")
		{
		remoteEval(2048, buyItem, $mt::fav[util::currentMod(), $curFavorites, "vehicle"]);
		remoteEval(2048, ToggleInventoryMode);
		}
	return;
}

//Heres where it gets interesting
function mt::execDropGroups (%time)
{
	mt::muteMoveButtons ();

	%one = $mt::fav[util::currentMod(), drop, $curFavorites, amount1];
	%two = $mt::fav[util::currentMod(), drop, $curFavorites, amount2];
	%thr = $mt::fav[util::currentMod(), drop, $curFavorites, amount3];
	%item1=$mt::fav[util::currentMod(), drop, $curFavorites, item1];
	%item2=$mt::fav[util::currentMod(), drop, $curFavorites, item2];
	%item3=$mt::fav[util::currentMod(), drop, $curFavorites, item3];
	%arm=invent::getCurrentArmour (); //(invent::getItemCount("Light Armor")*2)+(invent::getItemCount("Medium Armor")*3)+(invent::getItemCount("Heavy Armor")*4);  //Gotta do something about this cos some mods have more armour types :o\
	%all=(((%one>0)+(%two>0)+(%thr>0))==3);
	$mt::dropGroupStr="";

	if (!%all)
		%part=((((%one>0)+(%two>0))==2) || (((%one>0)+(%thr>0))==2) || (((%two>0)+(%thr>0))==2));

	//Do them one at a time I think
	if (%one)
		{
		if (!invent::isValidArmour (%item1, %arm))
			{
			%arm=invent::getValidArmour (%item1);
			$mt::dropGroupStr=$mt::dropGroupStr@"schedule (\"remoteEval (2048, buyItem, "@%arm@");\", "@%time@");";
			%time=%time+invent::ensureBuyDelay (%arm);
			}
		if (%all || %part)
			%time=mt::dropGroupLeft (%item1, %one, %time);
		else
			%time=mt::dropGroupMiddle (%item1, %one, %time);
		}

	if (%two)
		{
		if (!invent::isValidArmour (%item2, %arm))
			{
			%arm=invent::getValidArmour (%item2);
			$mt::dropGroupStr=$mt::dropGroupStr@"schedule (\"remoteEval (2048, buyItem, "@%arm@");\", "@%time@");";
			%time=%time+invent::ensureBuyDelay (%arm);
			}
		if (!%one && %part)
			%time=mt::dropGroupLeft (%item2, %two, %time);
		else
			%time=mt::dropGroupMiddle (%item2, %two, %time);
		}

	if (%thr)
		{
		if (!invent::isValidArmour (%item3, %arm))
			{
			%arm=invent::getValidArmour (%item3);
			$mt::dropGroupStr=$mt::dropGroupStr@"schedule (\"remoteEval (2048, buyItem, "@%arm@");\", "@%time@");";
			%time=%time+invent::ensureBuyDelay (%arm);
			}
		if (!%all)
			%time=mt::dropGroupMiddle (%item3, %thr, %time);
		else
			%time=mt::dropGroupRight (%item3, %thr, %time);
		}

	eval ($mt::dropGroupStr);
	return %time;
}

function mt::dropGroupLeft (%item, %amt, %time)
{
	%non=invent::nonInventItem (%item);
	if (%non!="" || $mt::favIsPortableOnly[util::currentMod, $curFavorites])
		return;
	%delay=invent::ensureBuyDelay (%item);
	%sell=invent::sellItemsFirst (%item);
	if (%sell!="")
		{
		$mt::dropGroupStr=$mt::dropGroupStr@"schedule(\"mt::sellFirstValid ('"@%sell@"');\", "@%time+0.2@");";
		%time=%time+0.4;
		}
	$mt::dropGroupStr=$mt::dropGroupStr@
						"schedule(\"mt::turnLeft();\", "@%time@");"@
						"schedule(\"mt::dropGroup ("@%item@", "@%amt@");\", "@%time+0.15@");"@
						"schedule(\"mt::turnRight();\", "@%time+%delay+0.2@");";
	return %time+%delay+0.3;
}

function mt::dropGroupRight (%item, %amt, %time)
{
	%non=invent::nonInventItem (%item);
	if (%non!="" || $mt::favIsPortableOnly[util::currentMod, $curFavorites])
		return;
	%delay=invent::ensureBuyDelay (%item);
	%sell=invent::sellItemsFirst (%item);
	if (%sell!="")
		{
		$mt::dropGroupStr=$mt::dropGroupStr@"schedule(\"mt::sellFirstValid ('"@%sell@"');\", "@%time+0.2@");";
		%time=%time+0.4;
		}
	$mt::dropGroupStr=$mt::dropGroupStr@
						"schedule(\"mt::turnRight ();\", "@%time@");"@
						"schedule(\"mt::dropGroup ("@%item@", "@%amt@");\", "@%time+0.15@");"@
						"schedule(\"mt::turnLeft();\", "@%time+%delay+0.2@");";
	return %time+%delay+0.3;
}

function mt::dropGroupMiddle (%item, %amt, %time)
{
	%non=invent::nonInventItem (%item);
	if (%non!="")
		return;
	%delay=invent::ensureBuyDelay (%item);
	%sell=invent::sellItemsFirst (%item);
	if (%sell!="")
		{
		$mt::dropGroupStr=$mt::dropGroupStr@"schedule(\"mt::sellFirstValid ('"@%sell@"');\", "@%time+0.2@");";
		%time=%time+0.4;
		}
	$mt::dropGroupStr=$mt::dropGroupStr@
						"schedule(\"mt::dropGroup ("@%item@", "@%amt@");\", "@%time+0.15@");";
	return %time+%delay+0.3;
}

function mt::dropGroup (%item, %amt)
{
	%temp="remoteEval (2048, buyItem, "@%item@");drop (\""@invent::item (%item)@"\");";
	for (%i=0;%i<%amt;%i++)
		%str=%str@%temp;

	eval (%str);
	return;
}

function mt::turnLeft ()
{
	postAction (2048, IDACTION_YAW, 0.10);
	return;
}

function mt::turnRight()
{
	postAction (2048, IDACTION_YAW, -0.10);
	return;
}

//The quick heal. Buys a number of repair kits according to armour type.
function mt::quickHeal ()
{
	if (!$util::bwadminStationType)
		%kits=invent::getCurrentArmour()+3;
	else
		%kits=$util::numOfKits;

	%str="remoteEval(2048, useItem, "@invent::item("Repair Kit")@");remoteEval(2048, buyItem, "@invent::item("Repair Kit")@");";
	for (%i=1;%i<=%kits;%i++)
		%string=%string@%str;
	eval (%string);
}

function mt::sellFirstValid (%itemList)
{
	for (%i=0; %i<999; %i++)
		{
		%item=getWord (%itemList, %i);
		if (getItemCount(invent::item (%item))>0)
			{
			remoteEval (2048, sellItem, %item);
			%i=999;
			}
		}
	return;
}

function mt::sellAllValid (%itemList)
{
	//do this later
	return;
}

function mt::setFavourite (%fav)
{
	$curFavorites=%fav;
	if ($mt::favOpensInventScreen[util::currentMod(), %fav])
		event::trigger(eventOpenInventOnEnter);
	else
		event::trigger(eventNoOpenInventOnEnter);

	infoHud::update ("preselect", $mt::favouriteName[%fav]);
//	remoteBP (2048, "<jc><f2>Preselected favourite: <fc>"@$mt::favouriteName[%fav]);
	if (mt::atInventory ())
		{
		remoteBP (2048, "<jc><f2>Bought and set preselected favourite: <fc>"@$mt::favouriteName[%fav]);
		mt::enteringInvent();
		}
}

function mt::anyMoveKeyPressed ()
{
	if ($mt::forwardPressed||$mt::backPressed||$mt::moveLeftPressed||$mt::moveRightPressed||$mt::jumpPressed||$mt::jetPressed)
		return true;
	else
		return false;
}

function mt::muteMoveButtons ()
{
	action::mute (forwardPressed,true);
	action::mute (backPressed,true);
	action::mute (moveLeftPressed,true);
	action::mute (moveRightPressed,true);
	action::mute (jumpPressed,true);
	action::mute (jumpReleased,true);
	action::mute (jetPressed,true);
}

function mt::releaseMoveButtons ()
{
	action::mute (forwardPressed,false);
	action::mute (backPressed,false);
	action::mute (moveLeftPressed,false);
	action::mute (moveRightPressed,false);
	action::mute (jumpPressed,false);
	action::mute (jumpReleased,false);
	action::mute (jetPressed,false);
}

function mt::restoreMovement ()
{
	if ($mt::forwardPressed)
		postAction(2048, IDACTION_MOVEFORWARD, 1.0);
	else if ($mt::backPressed)
		postAction(2048, IDACTION_MOVEBACK, 1.0);
	else if ($mt::moveLeftPressed)
		postAction(2048, IDACTION_MOVELEFT, 1.0);
	else if ($mt::moveRightPressed)
		postAction(2048, IDACTION_MOVERIGHT, 1.0);
	else if ($mt::jumpPressed)
		postAction(2048, IDACTION_MOVEUP, 1.0);
	else if ($mt::jetPressed)
		postAction(2048, IDACTION_JET, 1.0);
}

function mt::setAtInventory ()
	{ $mt::atInvent=true; }

function mt::setNotAtInventory ()
	{ $mt::atInvent=false; }

function mt::atInventory ()
	{ return $mt::atInvent; }

function mt::exitingStation ()
{
	infoHud::update ("preselect", $mt::favouriteName[$curFavorites]);
	mt::setNotAtInventory ();
	util::mountWeapon ($mt::fav[util::currentMod(), drop, $curFavorites, weapon], 1);
	if ($mt::fav[util::currentMod(), drop, $curFavorites, message]!="" && !$mt::quickBuyActive)
		say (1, $mt::fav[util::currentMod(), drop, $curFavorites, message]);
	$mt::quickBuyActive=false;
	return;
}
event::attach (eventQuickBuyActive, "$mt::quickBuyActive=true;");
function mt::initialiseDropFavs ()
{
	%mod=util::currentMod();
	for (%i=1;%i<50;%i++)
		{
		$mt::fav[%mod, drop, %i, amount1]=getWord ($inventoryDropGroup::[%mod, %i], 0);
		$mt::fav[%mod, drop, %i, amount2]=getWord ($inventoryDropGroup::[%mod, %i], 1);
		$mt::fav[%mod, drop, %i, amount3]=getWord ($inventoryDropGroup::[%mod, %i], 2);
		$mt::fav[%mod, drop, %i, item1] = getWord ($inventoryDropGroup::[%mod, %i], 3);
		$mt::fav[%mod, drop, %i, item2] = getWord ($inventoryDropGroup::[%mod, %i], 4);
		$mt::fav[%mod, drop, %i, item3] = getWord ($inventoryDropGroup::[%mod, %i], 5);
		$mt::fav[%mod, drop, %i, weapon]= getWord ($inventoryDropGroup::[%mod, %i], 6);
		}
	return;
}

function mt::checkValidPreselect ()
{
	if ($curFavorites<1 || $curFavorites>50)
		$curFavorites=1;
	return;
}

function mt::unmuteKeysOnDeath (%killer, %victim)
{
	if (%victim==getManagerId())
		mt::releaseMoveButtons ();
	return;
}

function mt::checkForBackPack ()
{
	if (getMountedItem (1)==-1)
		util::checkBackPack ();
	return;
}

function mt::toggleDropGroup ()
{
	if ($mt::doDropGroup)
		{
		$mt::doDropGroup=false;
		remoteBP (2048, "<jc><f2>Drop group cancelled");
		}
	else
		{
		$mt::doDropGroup=true;
		remoteBP (2048, "<jc><f2>Drop group reinstated");
		}
	return;
}

function remotebwadmin::StationInfo (%type, %noofkits)
{
	if (%client!=2048)
		return;

	$util::inventType=%type;
	$util::numOfKits=%noofkits;
}

$mt::doDropGroup=true;

event::attach (eventInventTypeUnkown, "mt::enteringInvent();mt::setAtInventory ();");
event::attach (eventBaseInvent, "mt::enteringInvent();mt::setAtInventory ();");
event::attach (eventPortableInvent, "mt::enteringPortableInvent();mt::setAtInventory ();");
event::attach (eventVehicleStation, mt::enteringVehicleStation);
event::attach (eventExitStation, mt::exitingStation);
event::attach (eventExitStation, mt::checkForBackPack);
event::attach (eventEnterStation, mt::checkValidPreselect);
event::attach (eventKillTrak, mt::checkValidPreselect);

infoHud::addNew ("preselect", "Fav", "default", "30");

//SimGui::ProgressCtrl