// infoHud.cs by Mental Trousers

function infoHud::new (%name, %maxSize, %initText)
{
	%ind=$infoHud::count;
	$infoHud::count++;
	$infoHud::item[$infoHud::count, "index"]=%maxSize;
	$infoHud::item[$infoHud::count, "name"] =%name;

	while ($infoHud::item[%ind, "index"]>%maxSize)
		{
		%temp=$infoHud::item[%ind, "index"];
		$infoHud::item[%ind, "index"]=%maxSize;
		$infoHud::item[%ind+1, "index"]=%temp;

		%temp=$infoHud::item[%ind, "name"];
		$infoHud::item[%ind, "name"]=%name;
		$infoHud::item[%ind+1, "name"]=%temp;

		%ind--;
		}
	return;
}

function infoHud::addNew (%name, %label, %initText, %maxSize)
{
	if ($infoHud::exists[%name])
		return;

	$infoHud::exists[%name]=true;
	infoHud::new (%name, %maxSize, %initText);
	$infoHud::[%name, "maxSize"]=%maxSize+8;
	if (%label!="")
		$infoHud::[%name, "label"]="<f3>"@%label@" <f2>";
	$infoHud::[%name, "text"]=infoHud::getFormattedString (%name, %initText);
	return;
}

function infoHud::getFormattedString (%name, %text)
{
	%temp="                                                                                      ";
	%fixed=infoHud::getFormattedString_ (%name, %text);
	%fixed=%fixed@string::getSubStr (%temp, 0, $infoHud::[%name, "maxSize"]-string::len (%fixed));
	return %fixed;
}

function infoHud::getFormattedString_ (%name, %text)
	{ return string::getSubStr ($infoHud::[%name, "label"]@%text,0 , $infoHud::[%name, "maxSize"]); }

function infoHud::clearGeneral()
{
	if (!$filter::stayVis)
		infoHud::update ("general", "");
	else
		schedule::add ("infoHud::clearGeneral();", 1);
}

function infoHud::update (%name, %val)
{
	$infoHud::[%name, "text"]=infoHud::getFormattedString (%name, %val);
	$infoHud::changed=true;
	$filter::stayVis=false;

	if ($infoHud::mode=="onChange")
		%time=$infoHud::show;
	else if ($infoHud::mode=="permanent")
		%time=0;

	if (!$filter::stayVis)
		%text=infoHud::getFullText ();
	else
		%text=%val;

	if (%name=="general")
		{
		if (%val!="")
			schedule::add ("infoHud::clearGeneral();", 15);
		%time=0;
		}

	infoHud::show (%text, %time);
	return;
}

function infoHud::show (%text, %time)
{
	if (%text=="")
		return;

	$infoHud::changed=false;
	remoteBP (2048, %text, 0);
	HUD::Display(hudTeam, false);
	if ($infoHud::mode!="permanent" && %time!=0)
		schedule::add ("remoteBP (2048, \"\");HUD::Display(hudTeam, true);", %time);
}

function infoHud::getFullText ()
{
	if ($infoHud::changed)
		{
		%text=" ";
		for (%i=1;%i<=$infoHud::count;%i++)
			{
			%name=$infoHud::item[%i, "name"];
			if (%name=="general" && $infoHud::["general", "text"]=="")
				{
				%text=%text@"<f3>"@$infoHud::[%name, "text"];
				continue;
				}
			else
				{
				%len=%len+$infoHud::[%name, "maxSize"]-8;
				if (%len>$infoHud::maxChars && %name!="general")
					{
					%len=$infoHud::[%name, "maxSize"]-8;
					%text=%text@"\n ";
					}
				%text=%text@$infoHud::[%name, "text"];
				}
			}
		}
	return %text;
}

function infoHud::init ()
{
	$infoHud::originalEvery=$infoHud::every;
	$infoHud::originalShow=$infoHud::show;
	if ($infoHud::mode=="permanent")
		$infoHud::show=0; 
	return;
}

event::attach (eventPlayerFirstSpawn, infoHud::init);

infoHud::addNew ("general", "", "", 1000);

//$infoHud::mode="permanent";          //possible modes "onChange", "permanent"
//$infoHud::show=3;                    //not used if mode is "permanent"
