// quickBuys.cs by Mental Trousers

//queue items up before going into the invent.
//push the action map more often.

include ("mt\\infoHud.cs");
include ("mt\\favourites.cs");
include ("mt\\station.cs");

function mt::toggleQueueMap()
{
	if ($mt::queueKeyMap)
		{
		$mt::queueKeyMap=false;
		popActionMap ("MTQuickBuysMap.sae");
		}
	else
		{
		$mt::queueKeyMap=true;
		pushActionMap ("MTQuickBuysMap.sae");
		}
	return;
}

function mt::queueQuickBuy (%item)
{
	if ($mt::queueKeyMap)
		$mt::quickBuyQueue=$mt::quickBuyQueue@" "@%item;
	else
		$mt::quickBuyQueue=%item;

	infoHud::update ("general", "Queued item "@$mt::quickBuy[util::currentMod(), %item]);
	$mt::queueLength++;
	$mt::queueKeyMap=false;
	popActionMap ("MTQuickBuysMap.sae");
	return;
}

function mt::quickBuy (%item)
{
	if (!$mt::enableQuickBuyKeys)
		return;
	mt::quickBuy_ (%item, 0);
}

function mt::quickBuy_ (%item, %time)
{	
	event::trigger (eventQuickBuyActive);
	if (%time=="")
		%time=0;
	$mt::quickBuyStr="";
	%item_=invent::item ($mt::quickBuy[util::currentMod(), %item]);
	%sell=invent::sellItemsFirst (%item_);
	%arm=invent::getCurrentArmour ();

	if (!invent::isValidArmour (%item_, %arm))
		{
		%arm=invent::getValidArmour (%item_);
		$mt::quickBuyStr="schedule (\"remoteEval (2048, buyItem, "@%arm@");\", "@%time@");";
		%time=%time+invent::ensureBuyDelay (%arm);
		}

	if (%sell!="")
		{
		$mt::quickBuyStr=$mt::quickBuyStr@"schedule(\"mt::sellFirstValid ('"@%sell@"');\", "@%time@");";
		%time=%time+0.2;
		}

	$mt::quickBuyStr=$mt::quickBuyStr@"schedule (\"remoteEval (2048, buyItem, "@%item_@");\", "@%time@");";

	eval ($mt::quickBuyStr);
	return %time;
}

function mt::getQuickBuys ()
{
	if ($mt::quickBuyQueue=="")
		return;

	%time=0.1;
	for (%i=0;%i<$mt::queueLength;%i++)
		{
		%item=getWord ($mt::quickBuyQueue, %i);
		%time=mt::quickBuy_ (%item, %time);
		}
	$mt::quickBuyQueue="";
	$mt::queueLength=0;
	return;
}

event::attach (eventFavouritesBought, mt::getQuickBuys);
event::attach (eventFavouritesBought, "$mt::enableQuickBuyKeys=true;");
event::attach (eventExitStation, "$mt::enableQuickBuyKeys=false;popActionMap (\"MTQuickBuysMap.sae\");popActionMap (\"MTStationMap.sae\");");
event::attach (eventBaseInvent, "pushActionMap (\"MTStationMap.sae\");");
event::attach (eventPortableInvent, "pushActionMap (\"MTStationMap.sae\");");
event::attach (eventInventTypeUnkown, "pushActionMap (\"MTStationMap.sae\");");
event::attach (eventEnterStation, "pushActionMap (\"MTQuickBuysMap.sae\");");
