// showWeapon.cs by Mental Trousers
//
// change the name and put in stuff to show what backpack you've got, grenades, mines, health kits etc.
// also put something in the infoHud like a callback so other stuff will be updated when the window pops up.

include ("mt\\infoHud.cs");

function mt::setShowItems (%mod)
{
	if (%mod!="base" || $mt::showWeapon)
		{
		infoHud::addNew ("weapon", "Weapon", "unknown", "20");
		event::attach (eventWeaponChanged, mt::showWeaponInHud);
		}
	else
		event::detach (eventWeaponChanged, mt::showWeaponInHud);

	if ($mt::showBackpack)
		{
		infoHud::addNew ("backpack", "Pack", "unknown", "20");
		action::attach (useBackpackReleased, mt::showBackpackInHud);
		}

	if ($mt::showMines)
		{
		infoHud::addNew ("mines", "Mines", "0", "9");
		action::attach (throwMineReleased, mt::showMines);
		}

	if ($mt::showGrenades)
		{
		infoHud::addNew ("grenades", "Grens", "0", "9");
		action::attach (throwGrenadeReleased, mt::showGrenades);
		}

	if ($mt::showHealthKit)
		{
		infoHud::addNew ("healthkit", "Kit", "0", "9");
		action::attach (useRepairKitReleassed, mt::showHealthKit);
		}

	return;
}

function mt::showWeaponInHud (%weap)
	{ infoHud::update ("weapon", invent::item(%weap)); }

function mt::showBackpackInHud ()
	{ schedule ("infoHud::update (\"backpack\", invent::item(getMountedItem(1)));", 0.3); }

function mt::showMines ()
	{ schedule ("infoHud::update (\"mines\", invent::getItemCount (\"Mine\"));", 0.3); }

function mt::showGrenades ()
	{ schedule ("infoHud::update (\"grenades\", invent::getItemCount (\"Grenade\"));", 0.3); }

function mt::showHealthKit ()
	{ schedule ("infoHud::update (\"healthkit\", invent::getItemCount (\"Repair Kit\"));", 0.3); }

function mt::updateAllShows ()
{
	mt::showBackpackInHud ();
	mt::showMines ();
	mt::showGrenades ();
	mt::showHealthKit ();
	return;
}

function mt::killUpdate (%killer, %client)
{
	%me=getManagerId();
	if (%killer==%me || %client==%me)
		mt::updateAllShows ();
	return;
}

event::attach (eventStoppedMineLoop, mt::showMines);
event::attach (eventStoppedGrenadeLoop, mt::showGrenades);
event::attach (eventPickedUpBackPack, mt::showBackpackInHud);
event::attach (eventExitStation, mt::updateAllShows);
event::attach (eventEstablishedMod, mt::setShowItems);
event::attach (eventPlayerFirstSpawn, mt::updateAllShows);
event::attach (eventKillTrak, mt::killUpdate);
