include ("mt\\infoHud.cs");

function sniper::isZoomedIn ()
	{ return $sniper::zoomPressed; }

function sniper::zoomInAndSwap ()
{
	if (mt::isInPilotMode ())
		return;

	sniper::customZoomLevel ();

	%weap=invent::getMountOnZoomWeapon ();
	if (%weap!="")   //invent::carryingItem (invent::getItemType ("Laser Rifle")))
		{
		sniper::showEnergyBar ();
		$previousWeapon=getMountedItem(0);
		if (!invent::isMountOnZoom (getMountedItem(0)))     //getMountedItem(0)!=invent::getItemType("Laser Rifle"))
			util::mountWeapon (%weap);                     //invent::getItemType("Laser Rifle"));
		}
	return;
}

function sniper::showEnergyBar ()
{
	addToSet (playGui, $sniper::energyBar);
	return;
}

function sniper::hideEnergyBar ()
{
	removeFromSet (playGui, $sniper::energyBar);
	return;
}

function sniper::zoomOutAndSwap ()
{
	if (mt::isInPilotMode())
		return;

	sniper::undoCustomZoomLevel ();
	sniper::hideEnergyBar ();

	if (invent::getItemCount ("Laser Rifle")==1)
		{
		if (getMountedItem(0)==invent::getItemType("Laser Rifle"))
			util::mountWeapon ($previousWeapon);
		}
	if ($sniper::useMagnificationReturn)
		sniper::backToBaseMag ();
	return;
}

function sniper::zoomSensitivity()
{
	%zoom=$sniper::zoom::[$sniper::currentZoom, "magnification"];
	%base=$NewPrefs::baseSensitivity;
	%min=$sniper::minSensitivity;
	%max=$sniper::maxSensitivity;
	%range=%max-%min;
	%sens=%base - ((%base / 100 * %zoom) / 100 * %range);
	return %sens;
}

function sniper::customZoomLevel ()
{
	$pref::playerFov=90/$sniper::zoom::[$sniper::currentZoom, "magnification"];
	senseStack::request("mt\\zoom.cs", sniper::zoomSensitivity());
	return;
}

function sniper::undoCustomZoomLevel ()
{
	$pref::playerFov=$sniper::baseFov;
	senseStack::release("mt\\zoom.cs");
	return;
}

function sniper::backToBaseMag ()
{
	$sniper::currentZoom=$sniper::magnification::return;
	infoHud::update ("sniper", $sniper::zoom::[$sniper::currentZoom, "magnification"]);
//	remoteBP (2048, "<jc><f2>Zoom level: <f3>"@$sniper::zoom::[$sniper::currentZoom, "magnification"]);
}

function sniper::incMagnification ()
{
	$sniper::currentZoom++;
	if ($sniper::currentZoom>=$mt::numOfMagnifications)
		$sniper::currentZoom=0;

	%mag=$sniper::zoom::[$sniper::currentZoom, "magnification"];

	infoHud::update ("sniper", %mag);
//	remoteBP (2048, "<jc><f2>Zoom level: <f3>"@%mag);
	if (sniper::isZoomedIn ())
		sniper::customZoomLevel ();
	return;
}

function sniper::decMagnification ()
{
	$sniper::currentZoom--;
	if ($sniper::currentZoom<0)
		$sniper::currentZoom=$mt::numOfMagnifications-1;

	%mag=$sniper::zoom::[$sniper::currentZoom, "magnification"];

	infoHud::update ("sniper", %mag);
//	remoteBP (2048, "<jc><f2>Zoom level: <f3>"@%mag);
	if (sniper::isZoomedIn ())
		sniper::customZoomLevel ();
	return;
}

function sniper::init (%gui)
{
	if ($mt::initDone["zoom"] || %gui!="playGui")
		return;
	else
		schedule ("sniper::init_ ();", 5);
}

function sniper::init_ ()
{
	$mt::initDone["zoom"]=true;
	for (%i=0; %i<$mt::numOfMagnifications; %i++)
		$sniper::zoom::[%i, "magnification"]=getWord ($mt::magnification::[%i], 0);
	$sniper::energyBar=newObject ("zoomEnergyBar", fearGui::jetPackHud, $sniper::energyBarX, $sniper::energyBarY, 1, 1);
	return;
}

function sniper::setReverseFire()
{
	if ($sniper::setReverseFire)
		{
		action::mute (firePressed, true);
		$sniper::reverseFireSet=true;
		}
	return;
}

function sniper::setNormalFire()
{
	action::mute (firePressed, false);
	$sniper::reverseFireSet=false;
	return;
}

function sniper::reverseFire ()
{
	if ($sniper::reverseFireSet)
		postAction(2048, IDACTION_FIRE1, 1);
	action::completed (firePressed);
	return;
}

function sniper::checkIfGoToReverseFire (%weapon)
{
	if (invent::isReverseFireWeapon (%weapon))
		sniper::setReverseFire();
	else
		sniper::setNormalFire();
	return;
}

function sniper::mountAndFire (%weap)
{
	%weap_=invent::getItemType ($invent::item::["base", %weap]);
	if (invent::carryingItem (%weap_) && invent::haveAmmo (%weap_) && sniper::isZoomedIn () && invent::isMountOnZoom(getMountedItem (0)))
		{
		$sniper::zoomWeapon=getMountedItem (0);
		useItem (%weap_);
		schedule ("event::trigger (eventAltZoomWeapon);", 0.2);
		}
	return;
}

function sniper::altZoomFire ()
{
	postAction(2048, IDACTION_FIRE1, 1);
	return;
}

function sniper::stopAltZoomFire ()
{
	if ($sniper::zoomWeapon)
		postAction(2048, IDACTION_BREAK1, 1);
	return;
}

function sniper::remountPrimarySniperWeapon ()
{
	if (sniper::isZoomedIn () && !invent::isMountOnZoom(getMountedItem (0)))
		useItem ($sniper::zoomWeapon);
	$sniper::zoomWeapon="";
	return;
}

event::trigger (eventAltZoomWeaponStop);

$sniper::baseFov=$pref::playerFov;
$sniper::currentZoom=$sniper::magnification::return;

event::attach (eventGuiOpen, sniper::init);
event::attach (eventAltZoomWeapon, sniper::altZoomFire);
event::attach (eventAltZoomWeaponStop, sniper::stopAltZoomFire);
event::attach (eventAltZoomWeaponStop, "schedule(\"sniper::remountPrimarySniperWeapon();\", 0.3);");
event::attach (eventWeaponChanged, sniper::checkIfGoToReverseFire);

action::mute (zoomPressed, true);
action::mute (zoomReleased, true);
action::mute (zoomMagnificationPressed, true);
action::mute (zoomMagnificationDecPressed, true);

action::attach::pre (fireReleased, sniper::reverseFire);
action::attach (zoomPressed, "$sniper::zoomPressed=true;");
action::attach (zoomReleased, "$sniper::zoomPressed=false;");
action::attach (zoomPressed, sniper::zoomInAndSwap);
action::attach (zoomReleased, sniper::stopAltZoomFire);
action::attach (zoomReleased, sniper::zoomOutAndSwap);
action::attach (zoomMagnificationPressed, sniper::incMagnification);
action::attach (zoomMagnificationDecPressed, sniper::decMagnification);

action::attach ("useBlasterPressed", "sniper::mountAndFire(11);");
action::attach ("useChaingunPressed", "sniper::mountAndFire(13);");
action::attach ("usePlasmaGunPressed", "sniper::mountAndFire(15);");
action::attach ("useGrenadeLauncherPressed", "sniper::mountAndFire(17);");
action::attach ("useMortarPressed", "sniper::mountAndFire(19);");
action::attach ("useDiscLauncherPressed", "sniper::mountAndFire(21);");
//action::attach ("useLaserRiflePressed", "sniper::mountAndFire(22);");
action::attach ("useTargetingLaserPressed", "sniper::mountAndFire(23);");
action::attach ("useELFGunPressed", "sniper::mountAndFire(24);");

action::attach ("useBlasterReleased", "event::trigger (eventAltZoomWeaponStop);");
action::attach ("useChaingunReleased", "event::trigger (eventAltZoomWeaponStop);");
action::attach ("usePlasmaGunReleased", "event::trigger (eventAltZoomWeaponStop);");
action::attach ("useGrenadeLauncherReleased", "event::trigger (eventAltZoomWeaponStop);");
action::attach ("useMortarReleased", "event::trigger (eventAltZoomWeaponStop);");
action::attach ("useDiscLauncherReleased", "event::trigger (eventAltZoomWeaponStop);");
//action::attach ("useLaserRifleReleased", "event::trigger (eventAltZoomWeaponStop);");
action::attach ("useTargetingLaserReleased", "event::trigger (eventAltZoomWeaponStop);");
action::attach ("useELFGunReleased", "event::trigger (eventAltZoomWeaponStop);");

NGS::register ("zoomEnergyBar");
infoHud::addNew ("sniper", "Zoom", $mt::magnification::[$sniper::magnification::return], 15);
