// backPack.cs by Mental Trousers
include ("mt\\infoHud.cs");

function mt::backPack ()
{
	if (getMountedItem(0)==invent::getItemType("Repair Gun"))
		{
		if ($mt::continueFiring)
			{
			$mt::continueFiring=false;
			postAction(2048, IDACTION_BREAK1, 1);
			action::mute (fireReleased, false);
			}
		else
			{
			$mt::continueFiring=true;
			action::mute (fireReleased, true);
			}
		}
	else
		{
		$mt::continueFiring=false;
		action::mute (fireReleased, false);
		}
}

function mt::resetFire ()
{
	$mt::continueFiring=false;
	action::mute (fireReleased, false);
	postAction(2048, IDACTION_BREAK1, 1);
}

function mt::rememberWeapon ()
{
	if (getMountedItem(0)!=invent::getItemType("Repair Gun"))
		$mt::prevWeapon=getMountedItem(0);
	action::completed (useBackpackPressed);
}

function mt::cancelRemounting ()
{
	if (getMountedItem(0)==invent::getItemType("Repair Gun"))
		{
		if ($mt::cancelRemountOnDone)
			{
			$mt::cancelRemountOnDone=false;
			remoteBP (2048, "<jc><f2>Weapon will not be remounted when finished", 3);
			}
		else
			{
			$mt::cancelRemountOnDone=true;
			remoteBP (2048, "<jc>Weapon will be remounted when finished", 3);
			}
		}
	action::completed (useBackpackPressed);
	return;
}

function mt::checkBackPackType ()
{
	if (mt::isInPilotMode())
		return;

	%pack=getMountedItem(1);
	if ((%pack==-1 || !invent::canDeployOrActivate (%pack)) && $mt::checkBackPack_)
		util::checkBackPack ();
	else if ($mt::mimicWritersMMB &&  !invent::canDeployOrActivate (%pack))
		{
		if (invent::carryingItem (invent::getMountOnZoomWeapon ())) 
			{
			if (getMountedItem(0)!=invent::getMountOnZoomWeapon ())
				{
				$mt::WriterBeforeLaser=getMountedItem(0);
				util::mountWeapon (invent::getMountOnZoomWeapon ());
				}
			else
				util::mountWeapon ($mt::WriterBeforeLaser);
			}
		else
			nextWeapon();
		}

	action::completed (useBackpackPressed);
	return;
}

function mt::remountWeapon()
{
	util::mountWeapon ($mt::prevWeapon);
}

function mt::weaponButtonPressed (%weap)
{
	if ($mt::continueFiring)
		{
		mt::resetFire ();
		remoteEval (2048, useItem, %weap);
		util::mountWeapon (%weap);
		}
}

function mt::cancelRepairNextWeapon ()
{
	if ($mt::continueFiring)
		{
		mt::resetFire ();
		nextWeapon();
		}
}

function mt::cancelRepairPrevWeapon ()
{
	if ($mt::continueFiring)
		{
		mt::resetFire ();
		prevWeapon();
		}
}

function mt::cancelAutoRepair()
{
	if ($mt::continueFiring)
		{
		mt::resetFire ();
		mt::remountWeapon();
		}
}

function mt::repairMessages (%client, %msg)
{
	//rewrite this with an event trigger when I get around to doing that part
	if (%client!=0)
		return;

	if (Match::ParamString (%msg, "Repairing %i"))
		$repairingItem=Match::Result(i);

	if (getClientByName($repairingItem)!=0)
		{
		$repairingItem="";
		say (0, "There you go "@$repairingItem);
		}
	else if ($repairingItem=="Scout"||$repairingItem=="LPC"||$repairingItem=="HPC")    //something for these
		$repairingItem="";

	return;
}

function mt::repairingSolar (%client, %msg)
{
	if (%client!=0 || !$mt::announce::["generator"])
		return;
	//replace this with an event trigger when I get around to doing that part
	if (getMountedItem(0)==invent::getItemType("Repair Gun") && $repairingItem!="" && $mt::repairingPower!="")
		say (1, $mt::repairingPower);
}

function mt::repairingGenerator (%client, %msg)
{
	if (%client!=0 || !$mt::announce::["generator"])
		return;
	//replace this with an event trigger when I get around to doing that part
	if (getMountedItem(0)==invent::getItemType("Repair Gun") && $repairingItem!="" && $mt::repairingPower!="")
		say (1, $mt::repairingPower);
}

function mt::repairsFinished()
{
	//replace this with an event trigger when I get around to doing that part
	if (!$mt::announce::["repairGeneral"])
		return;

	if (match::paramString ($repairingItem, "%i#%r"))
		$repairingItem=match::result (i);
	if ($repairingItem!="")
		say (1, "I've fixed the "@$repairingItem);
}

function mt::repairDone ()
{
	mt::resetFire();
	mt::repairsFinished();
	if (!$mt::cancelRemountOnDone)
		mt::remountWeapon();
	$mt::cancelRemountOnDone=false;
}

function mt::tryAndDeploy ()
{
	if ($mt::usePackHeld)
		{
		use("BackPack");
		schedule ("mt::tryAndDeploy ();", 0.1);
		}
	return;
}

function mt::deployCloser ()
{
	if ($mt::usePackHeld && $mt::deploy!=1)
		{
		postaction (2048, IDACTION_PITCHSPEED, -0.035);
		$mt::deploy=1;
		mt::tryAndDeploy ();
		}
	return;
}

function mt::deployFurther()
{
	if ($mt::usePackHeld && $mt::deploy!=2)
		{
		postaction (2048, IDACTION_PITCHSPEED, 0.035);
		$mt::deploy=2;
		mt::tryAndDeploy ();
		}
	return;
}

function mt::stopDeploying ()
{
	postaction (2048, IDACTION_PITCHSPEED, -0.0);
	$mt::deploy=0;
	return;
}

$mt::checkBackPack_=($mt::mimicWritersMMB==false) && $mt::checkBackPack; //ensures that checking the back pack and mimicking Writers are mutually exclusive
$mt::WriterBeforeLaser=21;

action::attach (firePressed, mt::backPack);
action::attach::pre (useBackpackPressed, mt::rememberWeapon);
action::attach::pre (useBackpackPressed, mt::cancelRemounting);
action::attach::pre (useBackpackPressed, mt::checkBackPackType);
action::attach (useBackpackReleased, mt::stopDeploying);
action::attach (useBackpackPressed, "$mt::usePackHeld=true;");
action::attach (useBackpackReleased, "$mt::usePackHeld=false;");

action::attach (useBlasterPressed, "mt::weaponButtonPressed(11);");
action::attach (useChaingunPressed, "mt::weaponButtonPressed(13);");
action::attach (usePlasmaGunPressed, "mt::weaponButtonPressed(15);");
action::attach (useGrenadeLauncherPressed, "mt::weaponButtonPressed(17);");
action::attach (useMortarPressed, "mt::weaponButtonPressed(19);");
action::attach (useDiscLauncherPressed, "mt::weaponButtonPressed(21);");
action::attach (useLaserRiflePressed, "mt::weaponButtonPressed(22);");
action::attach (useTargetingLaserPressed, "mt::weaponButtonPressed(23);");
action::attach (useELFGunPressed, "mt::weaponButtonPressed(24);");

action::attach (nextWeaponPressed, mt::cancelRepairNextWeapon);
action::attach (prevWeaponPressed, mt::cancelRepairPrevWeapon);

msg::onMatch ("Repair Stopped", "mt::repairDone();");
msg::onMatch ("is not damaged", "mt::resetFire();");
msg::onMatch ("Repair Done", "mt::repairDone ();");
msg::onMatch ("AutoRepair Off", "mt::cancelAutoRepair();");
msg::onMatch ("Nothing in range", "mt::resetFire();");
msg::onMatch ("Repairing", mt::repairMessages);
msg::onMatch ("olar panel", mt::repairingSolar);
msg::onMatch ("enerator", mt::repairingGenerator);

msg::onMatch ("Deploy position out of range", "mt::deployCloser ();");
msg::onMatch ("Unable to deploy - You're in the way", "mt::deployFurther();");
msg::onMatch ("deployed", "mt::stopDeploying ();");
